/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
#ifndef CONE_H
#define CONE_H

#include "Vector.h"
#include "Parameters.h"
#include "Node.h"
#include "Intersections.h"
#include "Ray.h"


/**
 * class Cone
 * 
 */

class Cone : public Node
{
 public:
  Cone(const Parameters&,const Vector& , const Vector&  , double );//a,b,rayon
  Cone (const Parameters&,const Vector& , const Vector&  , double , double);//a,axe,hauteur,rayon
  Cone(const Cone& );
  ~Cone ( ) {}

  int Inside (const Vector& p ) const;
  int Inside (const Node&) const;
  int Intersect(const Ray&, Intersections&) const;


 protected:


 private:

  Vector a;
  Vector b;
  Vector axe;
  double height;
  double rayon;
  //  double angle; <= plus tard ....

};

#endif // CONE_H
