/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
#ifndef CYLINDER_H
#define CYLINDER_H
#include "Parameters.h"
#include "Node.h"
#include "Intersections.h"
#include <string>

/**
 * class Cylinder
 * 
 */

class Cylinder : public Node
{
 public:
  
  Cylinder(const Parameters&);
  ~Cylinder ( );

  Cylinder (const Parameters&,const Vector& , const Vector&  , double ); // a, b, rayon
  Cylinder (const Parameters&,const Vector& , const Vector&  , double , double); // a, axe, heuteur, rayon
  Cylinder (const Cylinder& );

  int Inside (const Vector& p ) const;
  int Inside (const Node&) const;
  int Intersect(const Ray&, Intersections& ) const;

 protected:

 private:

  Vector a;
  Vector b;
  double r;
  Vector axe;
  Vector center;
  double height;
  //double angle; <= plus tard

};

#endif // CYLINDER_H
