/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
#ifndef NODE_H
#define NODE_H

#include <iostream>
#include <string>
#include "Vector.h"
#include "Ray.h"
#include "Parameters.h"
#include "Intersections.h"

/**
 * class Node
 * 
 */

class Node
{
 public:



  Node();
  Node(const Parameters& p);
  ~Node();
  Node (const Node& n);

  virtual int Inside (const Vector& ) const =0;
  virtual int Inside (const Node& ) const =0;
  virtual int Intersect (const Ray&, Intersections& ) const =0;
  

  void setParameters(const Parameters&);
  Parameters getParameters();


 protected:
  Parameters p;


 private:



};

#endif // NODE_H
