// Fast Raytracer
// Changelog 10.09.16

#ifndef __Sphere__
#define __Sphere__

//#include <iostream>
//using namespace std;

#include "Vector.h"
#include "Parameters.h"
#include "Node.h"
#include "Intersections.h"
#include "Ray.h"

// Material types are as follows 
// Diffuse : 0
// Specular : 1
// Refractive : 2

class Sphere : public Node
{ 
 public:
  double rad;       //!< Radius 
  Vector c;
 public:
  Sphere(const Parameters& );
  Sphere(const Parameters&, const Vector&, const double&);
  Sphere(const Sphere&);
  ~Sphere(){}
  int Intersect(const Ray&, Intersections& ) const;
  int Inside (const Vector& ) const;
  int Inside (const Node& ) const;
}; 

#endif
