/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
#include "Rotation.h"

Rotation::Rotation(const Parameters& p, const Node* n, const Vector& axe, double angle):Transformation(p,n){
  Rotation::axe = axe;
  Rotation::angle=angle;
  Vector a = Normalized(axe);
  double s = sinf(angle/180);
  double c = cosf(angle/180);

  Rotation::m=Matrix<double>(4,4);
  m.put(0, 0, a[0] * a[0] + (1.f - a[0] * a[0]) * c);
  m.put(0, 1, a[0] * a[1] * (1.f - c) - a[2] * s);
  m.put(0, 2, a[0] * a[2] * (1.f - c) + a[1] * s);
  m.put(1, 0, a[0] * a[1] * (1.f - c) + a[2] * s);
  m.put(1, 1, a[1] * a[1] + (1.f - a[1] * a[1]) * c);
  m.put(1, 2, a[1] * a[2] * (1.f - c) - a[0] * s);
  m.put(2, 0, a[0] * a[2] * (1.f - c) - a[1] * s);
  m.put(2, 1, a[1] * a[2] * (1.f - c) + a[0] * s);
  m.put(2, 2, a[2] * a[2] + (1.f - a[2] * a[2]) * c);
  m.put(3, 0, 0);
  m.put(3, 1, 0);
  m.put(3, 2, 0);
  m.put(3, 3, 1);
  //matrice de translation de l'objet à l'origine
  Matrix<double> tr(4,4);
  tr.put(0,0,1);
  tr.put(1,1,1);
  tr.put(2,2,1);
  tr.put(3,3,1);

  Vector pos = this->n->getParameters().getPosition();
  tr.put(0,3,-1*pos[0]);
  tr.put(1,3, -1*pos[1]);
  tr.put(2,3, -1*pos[2]);

  //matrice de translation inverse
  Matrix<double> trInv(4,4);
  /*trInv.put(0,0,1);
    trInv.put(1,1,1);
    trInv.put(2,2,1);
    trInv.put(3,3,1);
  */
  trInv = tr.getInverse();

  m = trInv*m*tr;

  //inverse de la matrice de rotation

  Rotation::mInverse = m.getInverse();
}




int Rotation::Intersect(const Ray& ray, Intersections& l ) const
{
	
  /*  Intersections i;
  double a = ray.Origin()[0];
  double b = ray.Origin()[1];
  double c = ray.Origin()[2];
  Vectortoto = Vector(	
		      mInverse.get(0, 0) * vec[0] + (*this)(0, 1) * vec[1] + (*this)(0, 2) * vec[2] + (*this)(0, 3),
			(*this)(1, 0) * vec[0] + (*this)(1, 1) * vec[1] + (*this)(1, 2) * vec[2] + (*this)(1, 3),
			(*this)(2, 0) * vec[0] + (*this)(2, 1) * vec[1] + (*this)(2, 2) * vec[2] + (*this)(2, 3));
  Ray r = Ray( mInverse*(Vector(ray.Origin()[0],ray.Origin()[1],ray.Origin()[2])),
	       int result = n->Intersect(r,i);

	       if(result){
		 return 1;
		 }*/
	       return 0;
	       /*Intersection tt;
		

		 mInv.MulDir(ray.Direction()));
		 if(left->Intersect(r,tt)){
		 t=tt;
		 t.pos = m.MulPt(t.pos);
		 t.normal = m.MulPt(t.normal);
		 t.obj = this->left;
		 return 1;
		 }
	
		 return 0;*/
	       }

    int Rotation::Inside (const Vector& pt ) const{
    return 1;
  }

  int Rotation::Inside (const Node&) const{
    return 1;
  }

